# Introduction

_**RARE (Router for Academia, Research & Education)**_ focus is on determining if a routing software platform  solution can fit R&E use cases. The project aims to integrate different pieces of software related to these building blocks:

* control plane
* data plane
* and communication between the control plane and data plane

A key part of the work consists in enabling a control plane software to pilot a data plane via a programmatic interface. P4 is such a language proposing an interface that allows data plane programmability. P4 core language try to be as much as possibble independent from the target or NPU processor architecture. Though architecture dependance is still prominent.  
Using P4 language leverages several existing software components. A feature rich dataplane software switch written in P4 is already available; communication between the control plane and data plane is also already part of the specification standard.

# Repository structure (Work in progress ...)
```
tree -d -L 1
rare/
├── bfrt_python
├── p4src
├── REFERENCE-LAB-MODEL
├── snmp
└── WEDGE100BF32X
``` 
bfrt_python contains bf_forwarder.py the GRPC client that communication with BFRuntime GRPC server
p4src folder contains the RARE P4 program
REFERENCE-LAB-MODEL folder contains an environment that runs RARE with TOFINO model
WEDGE100BF32X folder contains an environment that runs RARE with WEDGE100BF32X
snmp is a folder that contains files needed in order to provide basic WEDGE100BF32X/BF2556X-1T snmp statistics
BF2556X-1T folder contains an environment to start RARE with BF2556X-1T


# Dependencies
This repository essentially rely on Barefoot P4Studio software suite that can be downloaded from [BAREFOOT FASTER portal](https://forum.barefootnetworks.com/hc/en-us) (FASTER member only)

# Project partners
RARE is a GÉANT project with the following [partners](https://code.geant.net/stash/projects/RARE/repos/rare/browse/resources/rare-partners.md)

# Credits
All materials here inherit from several P4Lang public resources:
* [Csaba Mate](http://mc36.nop.hu/) for his excellent [FreeRTR](http://freerouter.nop.hu/)
* [BAREFOOT website](https://www.barefootnetworks.com/)
* [BAREFOOT R&E FASTER portal](https://forum.barefootnetworks.com/hc/en-us)
* [P4Lang project resources](https://p4.org/) 
* And others that I may have forgotten ...

